Index: drivers/char/joystick/gf2k.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/gf2k.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/gf2k.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/gf2k.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: gf2k.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: gf2k.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 1998-2000 Vojtech Pavlik
  *
Index: drivers/char/joystick/grip.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/grip.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/grip.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/grip.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: grip.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: grip.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 1998-2000 Vojtech Pavlik
  *
Index: drivers/char/joystick/iforce.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/iforce.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/iforce.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/iforce.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: iforce.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: iforce.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 2000-2001 Vojtech Pavlik <vojtech@suse.cz>
  *  Copyright (c) 2001 Johann Deneux <deneux@ifrance.com>
Index: drivers/char/joystick/interact.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/interact.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/interact.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/interact.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: interact.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: interact.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 2000 Vojtech Pavlik
  *
Index: drivers/char/joystick/lightning.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/lightning.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/lightning.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/lightning.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: lightning.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: lightning.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 1998-2001 Vojtech Pavlik
  *
Index: drivers/char/joystick/magellan.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/magellan.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/magellan.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/magellan.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: magellan.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: magellan.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 1999-2000 Vojtech Pavlik
  *
Index: drivers/char/joystick/ns558.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/ns558.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/ns558.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/ns558.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: ns558.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: ns558.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 1999-2001 Vojtech Pavlik
  *  Copyright (c) 1999 Brian Gerst
Index: drivers/char/joystick/pcigame.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/pcigame.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/pcigame.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/pcigame.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: pcigame.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: pcigame.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 2000-2001 Vojtech Pavlik
  *
Index: drivers/char/joystick/serio.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/serio.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/serio.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/serio.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: serio.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: serio.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 1999-2000 Vojtech Pavlik
  *
Index: drivers/char/joystick/serport.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/serport.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/serport.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/serport.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: serport.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: serport.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 1999-2001 Vojtech Pavlik
  *
Index: drivers/char/joystick/sidewinder.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/sidewinder.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/sidewinder.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/sidewinder.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: sidewinder.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: sidewinder.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 1998-2001 Vojtech Pavlik
  *
Index: drivers/char/joystick/spaceball.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/spaceball.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/spaceball.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/spaceball.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: spaceball.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: spaceball.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 1999-2000 Vojtech Pavlik
  *
Index: drivers/char/joystick/spaceorb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/spaceorb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/spaceorb.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/spaceorb.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: spaceorb.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: spaceorb.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 1999-2000 Vojtech Pavlik
  * 
Index: drivers/char/joystick/stinger.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/stinger.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/stinger.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/stinger.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: stinger.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: stinger.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 2000-2001 Vojtech Pavlik
  *  Copyright (c) 2000 Mark Fletcher
Index: drivers/char/joystick/tmdc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/tmdc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/tmdc.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/tmdc.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: tmdc.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: tmdc.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 1998-2000 Vojtech Pavlik
  *
Index: drivers/char/joystick/turbografx.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/turbografx.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/turbografx.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/turbografx.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: turbografx.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: turbografx.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 1998-2000 Vojtech Pavlik
  *
Index: drivers/char/joystick/warrior.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/joystick/warrior.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/joystick/warrior.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/joystick/warrior.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: warrior.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: warrior.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  *  Copyright (c) 1999-2000 Vojtech Pavlik
  *
Index: drivers/char/pcmcia/serial_cs.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/pcmcia/serial_cs.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/pcmcia/serial_cs.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/pcmcia/serial_cs.c	20 Oct 2004 22:34:38 -0000	1.2
@@ -337,7 +337,7 @@
 		link->conf.ConfigIndex = cf->index;
 		link->io.BasePort1 = cf->io.win[0].base;
 		link->io.IOAddrLines = (try == 0) ?
-		    16 : cf->io.flags & CISTPL_IO_LINES_MASK;
+		    10 : cf->io.flags & CISTPL_IO_LINES_MASK;
 		i = CardServices(RequestIO, link->handle, &link->io);
 		if (i == CS_SUCCESS) goto found_port;
 	    }
Index: drivers/char/pcmcia/synclink_cs.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/pcmcia/synclink_cs.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/pcmcia/synclink_cs.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/char/pcmcia/synclink_cs.c	4 Aug 2004 01:28:51 -0000	1.2
@@ -1,7 +1,7 @@
 /*
  * linux/drivers/char/synclink_cs.c
  *
- * $Id: synclink_cs.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+ * $Id: synclink_cs.c,v 1.2 2004/08/04 01:28:51 joff Exp $
  *
  * Device driver for Microgate SyncLink PC Card
  * multiprotocol serial adapter.
@@ -483,6 +483,7 @@
 
 static int debug_level = 0;
 static int maxframe[MAX_DEVICE_COUNT] = {0,};
+static int dosyncppp[MAX_DEVICE_COUNT] = {1,1,1,1};
 
 /* The old way: bit map of interrupts to choose from */
 /* This means pick from 15, 14, 12, 11, 10, 9, 7, 5, 4, and 3 */
@@ -499,9 +500,14 @@
 MODULE_PARM(cuamajor,"i");
 MODULE_PARM(debug_level,"i");
 MODULE_PARM(maxframe,"1-" __MODULE_STRING(MAX_DEVICE_COUNT) "i");
+MODULE_PARM(dosyncppp,"1-" __MODULE_STRING(MAX_DEVICE_COUNT) "i");
+
+#ifdef MODULE_LICENSE
+MODULE_LICENSE("GPL");
+#endif
 
 static char *driver_name = "SyncLink PC Card driver";
-static char *driver_version = "$Revision: 1.1 $";
+static char *driver_version = "$Revision: 1.2 $";
 
 static struct tty_driver serial_driver, callout_driver;
 static int serial_refcount;
@@ -871,6 +877,9 @@
 		printk(badmagic, kdevname(device), routine);
 		return 1;
 	}
+#else
+	if (!info)
+		return 1;
 #endif
 	return 0;
 }
@@ -2616,14 +2625,17 @@
 {
 	MGSLPC_INFO * info = (MGSLPC_INFO *)tty->driver_data;
 
-	if (!info || mgslpc_paranoia_check(info, tty->device, "mgslpc_close"))
+	if (mgslpc_paranoia_check(info, tty->device, "mgslpc_close"))
 		return;
 	
 	if (debug_level >= DEBUG_LEVEL_INFO)
 		printk("%s(%d):mgslpc_close(%s) entry, count=%d\n",
 			 __FILE__,__LINE__, info->device_name, info->count);
 			 
-	if (!info->count || tty_hung_up_p(filp))
+	if (!info->count)
+		return;
+
+	if (tty_hung_up_p(filp))
 		goto cleanup;
 			
 	if ((tty->count == 1) && (info->count != 1)) {
@@ -2747,7 +2759,7 @@
 			schedule_timeout(char_time);
 			if (signal_pending(current))
 				break;
-			if (timeout && ((orig_jiffies + timeout) < jiffies))
+			if (timeout && time_after(jiffies, orig_jiffies + timeout))
 				break;
 		}
 	} else {
@@ -2757,7 +2769,7 @@
 			schedule_timeout(char_time);
 			if (signal_pending(current))
 				break;
-			if (timeout && ((orig_jiffies + timeout) < jiffies))
+			if (timeout && time_after(jiffies, orig_jiffies + timeout))
 				break;
 		}
 	}
@@ -2937,16 +2949,11 @@
 	info = mgslpc_device_list;
 	while(info && info->line != line)
 		info = info->next_device;
-	if ( !info ){
-		printk("%s(%d):Can't find specified device on open (line=%d)\n",
-			__FILE__,__LINE__,line);
+	if (mgslpc_paranoia_check(info, tty->device, "mgslpc_open"))
 		return -ENODEV;
-	}
 	
 	tty->driver_data = info;
 	info->tty = tty;
-	if (mgslpc_paranoia_check(info, tty->device, "mgslpc_open"))
-		return -ENODEV;
 		
 	if (debug_level >= DEBUG_LEVEL_INFO)
 		printk("%s(%d):mgslpc_open(%s), old ref count = %d\n",
@@ -3008,6 +3015,8 @@
 	
 cleanup:			
 	if (retval) {
+		if (tty->count == 1)
+			info->tty = 0; /* tty layer will release tty struct */
 		if(MOD_IN_USE)
 			MOD_DEC_USE_COUNT;
 		if(info->count)
@@ -3181,8 +3190,7 @@
 	if (info->line < MAX_DEVICE_COUNT) {
 		if (maxframe[info->line])
 			info->max_frame_size = maxframe[info->line];
-//		info->dosyncppp = dosyncppp[info->line];
-		info->dosyncppp = 1;
+		info->dosyncppp = dosyncppp[info->line];
 	}
 
 	mgslpc_device_count++;
Index: drivers/char/rio/rio_linux.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/rio/rio_linux.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/rio/rio_linux.c	22 Jul 2004 19:49:53 -0000	1.1
+++ drivers/char/rio/rio_linux.c	4 Aug 2004 01:28:52 -0000	1.2
@@ -27,8 +27,8 @@
  *
  * Revision history:
  * $Log: rio_linux.c,v $
- * Revision 1.1  2004/07/22 19:49:53  joff
- * Initial revision
+ * Revision 1.2  2004/08/04 01:28:52  joff
+ * merging 2.4.26-vrs1
  *
  * Revision 1.1  1999/07/11 10:13:54  wolff
  * Initial revision
@@ -36,8 +36,8 @@
  * */
 
 
-#define RCS_ID "$Id: rio_linux.c,v 1.1 2004/07/22 19:49:53 joff Exp $"
-#define RCS_REV "$Revision: 1.1 $"
+#define RCS_ID "$Id: rio_linux.c,v 1.2 2004/08/04 01:28:52 joff Exp $"
+#define RCS_REV "$Revision: 1.2 $"
 
 
 #include <linux/module.h>
Index: drivers/cpufreq/userspace.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/cpufreq/userspace.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/cpufreq/userspace.c	22 Jul 2004 19:50:10 -0000	1.1
+++ drivers/cpufreq/userspace.c	4 Aug 2004 01:28:52 -0000	1.2
@@ -4,7 +4,7 @@
  *  Copyright (C)  2001 Russell King
  *            (C)  2002 - 2003 Dominik Brodowski <linux@brodo.de>
  *
- * $Id: userspace.c,v 1.1 2004/07/22 19:50:10 joff Exp $
+ * $Id: userspace.c,v 1.2 2004/08/04 01:28:52 joff Exp $
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
Index: drivers/gsc/dino.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/gsc/dino.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/gsc/dino.c	22 Jul 2004 19:49:29 -0000	1.1
+++ drivers/gsc/dino.c	4 Aug 2004 01:28:52 -0000	1.2
@@ -251,7 +251,7 @@
 	unsigned long flags; \
 	spin_lock_irqsave(&(DINO_DEV(d)->dinosaur_pen), flags); \
 	/* tell HW which IO Port address */ \
-	gsc_writel((u32) addr & ~3, d->base_addr + DINO_PCI_ADDR); \
+	gsc_writel((u32) addr, d->base_addr + DINO_PCI_ADDR); \
 	/* generate I/O PORT read cycle */ \
 	v = gsc_read##type(d->base_addr+DINO_IO_DATA+(addr&mask)); \
 	spin_unlock_irqrestore(&(DINO_DEV(d)->dinosaur_pen), flags); \
@@ -267,7 +267,7 @@
 { \
 	unsigned long flags; \
 	spin_lock_irqsave(&(DINO_DEV(d)->dinosaur_pen), flags); \
-	/* tell HW which CFG address */ \
+	/* tell HW which IO port address */ \
 	gsc_writel((u32) addr, d->base_addr + DINO_PCI_ADDR); \
 	/* generate cfg write cycle */ \
 	gsc_write##type(cpu_to_le##size(val), d->base_addr+DINO_IO_DATA+(addr&mask)); \
@@ -467,7 +467,7 @@
  * to set up the addresses of the devices on this bus.
  */
 #define _8MB 0x00800000UL
-static void __init
+static int __init
 dino_card_setup(struct pci_bus *bus, unsigned long base_addr)
 {
 	int i;
@@ -482,7 +482,7 @@
 				0xffffffffffffffffUL &~ _8MB, _8MB,
 				NULL, NULL) < 0) {
 		printk(KERN_WARNING "Dino: Failed to allocate memory region\n");
-		return;
+		return -ENODEV;
 	}
 	bus->resource[1] = res;
 	bus->resource[0] = &(dino_dev->hba.io_space);
@@ -495,6 +495,7 @@
 	gsc_writel(1 << i, base_addr + DINO_IO_ADDR_EN);
 
 	pcibios_assign_unassigned_resources(bus);
+	return 0;
 }
 
 static void __init
Index: drivers/hil/hp_sdc_rtc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/hil/hp_sdc_rtc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/hil/hp_sdc_rtc.c	22 Jul 2004 19:49:29 -0000	1.1
+++ drivers/hil/hp_sdc_rtc.c	4 Aug 2004 01:28:52 -0000	1.2
@@ -561,6 +561,7 @@
         }
         case RTC_ALM_READ:      /* Read the present alarm time */
         {
+		memset(&ttime, 0, sizeof(struct timeval));
 		if (hp_sdc_rtc_read_mt(&ttime)) return -EFAULT;
                 break;
         }
@@ -609,6 +610,7 @@
         }
         case RTC_RD_TIME:       /* Read the time/date from RTC  */
         {
+		memset(&wtime, 0, sizeof(struct rtc_time));
 		if (hp_sdc_rtc_read_bbrtc(&wtime)) return -EFAULT;
                 break;
         }
Index: drivers/hotplug/Config.in
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/hotplug/Config.in,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/hotplug/Config.in	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/hotplug/Config.in	4 Aug 2004 01:28:52 -0000	1.2
@@ -11,6 +11,7 @@
 if [ "$CONFIG_X86_IO_APIC" = "y" ]; then
    dep_tristate '  IBM PCI Hotplug driver' CONFIG_HOTPLUG_PCI_IBM $CONFIG_HOTPLUG_PCI $CONFIG_X86_IO_APIC $CONFIG_X86
 fi
-dep_tristate '  ACPI PCI Hotplug driver' CONFIG_HOTPLUG_PCI_ACPI $CONFIG_ACPI $CONFIG_HOTPLUG_PCI
-
+if [ "$CONFIG_ACPI_INTERPRETER" = "y" ]; then
+   dep_tristate '  ACPI PCI Hotplug driver' CONFIG_HOTPLUG_PCI_ACPI $CONFIG_HOTPLUG_PCI
+fi
 endmenu
Index: drivers/hotplug/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/hotplug/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/hotplug/Makefile	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/hotplug/Makefile	4 Aug 2004 01:28:52 -0000	1.2
@@ -27,10 +27,6 @@
 				ibmphp_res.o	\
 				ibmphp_hpc.o
 
-ifdef CONFIG_HOTPLUG_PCI_ACPI
-  EXTRA_CFLAGS	+= -D_LINUX -I$(CURDIR)/../acpi
-endif
-
 acpiphp_objs		:=	acpiphp_core.o	\
 				acpiphp_glue.o	\
 				acpiphp_pci.o	\
Index: drivers/hotplug/acpiphp.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/hotplug/acpiphp.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/hotplug/acpiphp.h	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/hotplug/acpiphp.h	4 Aug 2004 01:28:52 -0000	1.2
@@ -1,12 +1,12 @@
 /*
  * ACPI PCI Hot Plug Controller Driver
  *
- * Copyright (c) 1995,2001 Compaq Computer Corporation
- * Copyright (c) 2001 Greg Kroah-Hartman (greg@kroah.com)
- * Copyright (c) 2001 IBM Corp.
- * Copyright (c) 2002 Hiroshi Aono (h-aono@ap.jp.nec.com)
- * Copyright (c) 2002 Takayoshi Kochi (t-kouchi@cq.jp.nec.com)
- * Copyright (c) 2002 NEC Corporation
+ * Copyright (C) 1995,2001 Compaq Computer Corporation
+ * Copyright (C) 2001 Greg Kroah-Hartman (greg@kroah.com)
+ * Copyright (C) 2001 IBM Corp.
+ * Copyright (C) 2002 Hiroshi Aono (h-aono@ap.jp.nec.com)
+ * Copyright (C) 2002,2003 Takayoshi Kochi (t-kochi@bq.jp.nec.com)
+ * Copyright (C) 2002,2003 NEC Corporation
  *
  * All rights reserved.
  *
@@ -26,15 +26,14 @@
  * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  * Send feedback to <gregkh@us.ibm.com>,
- *		    <h-aono@ap.jp.nec.com>,
- *		    <t-kouchi@cq.jp.nec.com>
+ *		    <t-kochi@bq.jp.nec.com>
  *
  */
 
 #ifndef _ACPIPHP_H
 #define _ACPIPHP_H
 
-#include "include/acpi.h"
+#include <linux/acpi.h>
 #include "pci_hotplug.h"
 
 #if ACPI_CA_VERSION < 0x20020201
@@ -71,7 +70,7 @@
 	return AE_OK;
 }
 #else  /* ACPI_CA_VERSION < 0x20020201 */
-#include "acpi_bus.h"
+#include <acpi/acpi_bus.h>
 #endif
 
 /* compatibility stuff for ACPI CA */
@@ -107,7 +106,7 @@
 
 #define SLOT_MAGIC	0x67267322
 /* name size which is used for entries in pcihpfs */
-#define SLOT_NAME_SIZE	32		/* ACPI{_SUN}-{BUS}:{DEV} */
+#define SLOT_NAME_SIZE	16		/* {_SUN} */
 
 struct acpiphp_bridge;
 struct acpiphp_slot;
@@ -270,11 +269,7 @@
 #define FUNC_HAS_PS2		(0x00000040)
 #define FUNC_HAS_PS3		(0x00000080)
 
-/* not yet */
-#define SLOT_SUPPORT_66MHZ	(0x00010000)
-#define SLOT_SUPPORT_100MHZ	(0x00020000)
-#define SLOT_SUPPORT_133MHZ	(0x00040000)
-#define SLOT_SUPPORT_PCIX	(0x00080000)
+#define FUNC_EXISTS		(0x10000000) /* to make sure we call _EJ0 only for existing funcs */
 
 /* function prototypes */
 
Index: drivers/hotplug/acpiphp_core.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/hotplug/acpiphp_core.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/hotplug/acpiphp_core.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/hotplug/acpiphp_core.c	4 Aug 2004 01:28:52 -0000	1.2
@@ -1,12 +1,12 @@
 /*
  * ACPI PCI Hot Plug Controller Driver
  *
- * Copyright (c) 1995,2001 Compaq Computer Corporation
- * Copyright (c) 2001 Greg Kroah-Hartman (greg@kroah.com)
- * Copyright (c) 2001 IBM Corp.
- * Copyright (c) 2002 Hiroshi Aono (h-aono@ap.jp.nec.com)
- * Copyright (c) 2002 Takayoshi Kochi (t-kouchi@cq.jp.nec.com)
- * Copyright (c) 2002 NEC Corporation
+ * Copyright (C) 1995,2001 Compaq Computer Corporation
+ * Copyright (C) 2001 Greg Kroah-Hartman (greg@kroah.com)
+ * Copyright (C) 2001 IBM Corp.
+ * Copyright (C) 2002 Hiroshi Aono (h-aono@ap.jp.nec.com)
+ * Copyright (C) 2002,2003 Takayoshi Kochi (t-kochi@bq.jp.nec.com)
+ * Copyright (C) 2002,2003 NEC Corporation
  *
  * All rights reserved.
  *
@@ -26,8 +26,7 @@
  * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  * Send feedback to <gregkh@us.ibm.com>,
- *                  <h-aono@ap.jp.nec.com>,
- *		    <t-kouchi@cq.jp.nec.com>
+ *		    <t-kochi@bq.jp.nec.com>
  *
  */
 
@@ -57,7 +56,7 @@
 static int num_slots;
 
 #define DRIVER_VERSION	"0.4"
-#define DRIVER_AUTHOR	"Greg Kroah-Hartman <gregkh@us.ibm.com>, Takayoshi Kochi <t-kouchi@cq.jp.nec.com>"
+#define DRIVER_AUTHOR	"Greg Kroah-Hartman <gregkh@us.ibm.com>, Takayoshi Kochi <t-kochi@bq.jp.nec.com>"
 #define DRIVER_DESC	"ACPI Hot Plug PCI Controller Driver"
 
 MODULE_AUTHOR(DRIVER_AUTHOR);
@@ -376,10 +375,8 @@
  */
 static void make_slot_name (struct slot *slot)
 {
-	snprintf(slot->hotplug_slot->name, SLOT_NAME_SIZE, "ACPI%d-%02x:%02x",
-		 slot->acpi_slot->sun,
-		 slot->acpi_slot->bridge->bus,
-		 slot->acpi_slot->device);
+	snprintf(slot->hotplug_slot->name, SLOT_NAME_SIZE, "%u",
+		 slot->acpi_slot->sun);
 }
 
 /**
